require 'conformity/version'
require 'capybara'

begin
  require 'capybara/poltergeist'
  poltergeist = true
rescue Gem::LoadError
  poltergeist = false
end

require 'conformity/actions'
require 'conformity/form'
require 'conformity/field'
require 'conformity/fields'
require 'conformity/success_conditions'

module Conformity
  class ConformityError < StandardError; end
  class ActionError < ConformityError; end
  class FieldError < ConformityError; end

  class << self
    attr_writer :log_screenshots
    attr_accessor :screenshots_folder

    def configure
      yield self
    end

    def log_screenshots
      @log_screenshots ||= false
    end
  end
end

Capybara.configure do |config|
  config.run_server = false
  if poltergeist
    config.default_driver = :poltergeist
  else
    config.default_driver = :selenium
  end
end
