module Conformity
  class Field
    attr_reader :name, :options
    attr_accessor :type

    def initialize(name, options = {})
      @name = name
      @options = options[:options]
      @required = options[:required] || false
    end

    def required?
      @required
    end

    def value
      if @value
        @value
      elsif required?
        raise FieldError, "Required field '#{name}' not set"
      end
    end

    def value=(value)
      if @options && !@options.include?(value)
        raise FieldError, "#{value} not in #{@options}"
      end

      @value = value
    end
  end
end
