module Conformity
  class Fields
    def fields
      @fields ||= []
    end

    def add_field(field)
      fields << field
    end

    def add_new_field(name, opts={})
      add_field(Field.new(name, opts))
    end

    def field_names
      fields.map { |field| field.name }
    end

    def find(name)
      fields.select { |field| field.name == name }.first
    end

    def value(name)
      find(name).value
    end

    def set(name, value)
      find(name).value = value
    end

    def set_all(hash)
      hash.each { |name, value| set(name, value) unless find(name).nil? }
    end
  end
end
