module Conformity
  class SuccessConditions

    def initialize(session = Capybara.current_session)
      @session = session
      @conditions = []
    end

    def has_content?(content)
      add_condition do
        session.has_content?(content)
      end
    end

    def has_status_code?(status_code)
      add_condition do
        session.status_code == status_code
      end
    end

    def success?
      conditions.all? { |condition| condition.call() }
    end

  private
    attr_reader :session, :conditions

    def add_condition(&block)
      conditions << block
    end
  end
end
